<template>
  <section class="section-events container">
    <h1>События</h1>
    <p>Фильтр по типу:
      <label v-for="eventType in eventTypes" :key="eventType" class="me-2"><input type="checkbox" :value="eventType" v-model="filteredEventTypes">
        {{ eventType }}</label>
    </p>
    <p><label>Поиск по названию: <input style="outline: none;" type="search" v-model="eventTitle"></label></p>
    <ul class="events list-unstyled">
      <li class="event" v-for="event in events" :key="event.id" v-if="filteredEventTypes.includes(event.type) && event.title.toLowerCase().includes(eventTitle.toLowerCase())">
        <router-link :to="'/events/' + event.id" class="position-relative mb-3">
          <img class="event__image img-fluid" :src="event.cover" :alt="event.title">
          <span class="event__type">{{event.type}}</span>
        </router-link>
        <p class="event__title">{{event.title}}</p>
        <p class="mt-auto"><span class="fw-bold">{{event.price}}₽</span> • {{event.begins_at | formatEventDate}}</p>
        <p>Свободных мест осталось: {{event.vacancies_amount}}</p>
        <router-link class="btn btn-primary border-radius" :to="'/events/' + event.id">Подробнее</router-link>
      </li>
    </ul>
  </section>
</template>

<script>
import axios from "axios"

export default {
  name: "Events",
  data() {
    return {
      events: [],
      eventTitle: '',
      filteredEventTypes: []
    }
  },
  filters: {
    formatEventDate(date) {
      const formatter = new Intl.DateTimeFormat("ru", {
        weekday: "short",
        month: "long",
        day: "2-digit"
      });
      return formatter.format(new Date(date))
    }
  },
  created() {
    axios
        .get('events/')
        .then(({data: events}) => {
          this.events = events
          this.filteredEventTypes = [...events.map(event => event.type)]
        })
        .catch(({response}) => {
          if (response.statusText === 'Unauthorized') {
            localStorage.removeItem('token')
            this.$router.push('/login')
          }
        })
  },
  computed: {
    eventTypes() {
      return [...this.events.map(event => event.type)]
    }
  }
}
</script>

<style lang="scss">
$borderRadius: 10px;

.border-radius {
  border-radius: 9px;
}

.event__image {
  border-radius: 8px;
}

.event {
  border: 1px solid grey;
  border-radius: $borderRadius;
  display: flex;
  flex-direction: column;
}

.event__type {
  position: absolute;
  top: 8px;
  right: 8px;
  font-size: 0.875rem;
  background: #42b983;
  color: #fff;
  border-radius: 10px;
  padding: 0 12px;
}

.event__title {
  font-weight: 700;
  font-size: 1.5rem;
  line-height: 1.1;
  padding: 0 8px;
}

.events {
  display: grid;
  gap: 30px;
}

@media (min-width: 992px) {
  .events {
    grid-template-columns: repeat(3, 1fr);
  }
}

@media (min-width: 576px) and (max-width: 991px) {
  .events {
    grid-template-columns: 1fr 1fr;
  }
}

@media (max-width: 575px) {
  .events {
    grid-template-columns: 1fr;
  }
}

</style>